


#from .utils.image_plotting import OnlineImagePlotter
from . import utils.image_plotting.OnlineImagePlotter as OnlineImagePlotter
import matplotlib.pyplot as plt
from matplotlib.backends.backend_agg import FigureCanvasAgg

import numpy as np

def plot_data(data):

    print("AGIPD MODULE PLOTE FUNCTION CALLED! suing pyplot to plot...")
    plt.switch_backend("agg")
    fig = plt.figure(figsize=(15,10))

    plt.imshow(data, interpolation=None)

    plt.title(f"this is my plot")
    plt.xlabel('kbar')
    plt.ylabel('Pk')

    canvas = FigureCanvasAgg(fig)
    canvas.draw()
    image_buffer = np.frombuffer(canvas.buffer_rgba(), dtype=np.uint8).reshape(
        canvas.get_width_height()[::-1] + (4,))
            
    plt.close(fig)
    print("AGIPD MODULE PLOTE FUNCTION CALLED! ... DONE")
    return image_buffer


class AgipdModulePlotter():

    def __init__(self):
        print("AGIPD PLOTTER INIT")
        self.onlineImagePlotter = OnlineImagePlotter(figsize=(15,10))


    
    def plot(self, train_id, module_data):
        print("AGIPD PLOTTER PLOT")
        if module_data.shape != (512, 128):
            print(f"Error, AgipdModulePlotter.plot received data must be of shape (512, 128), and not {module_data.shape}")
            return
        
        print("AGIPD PLOTTER call get image buffer")
        img = self.onlineImagePlotter.get_image_buffer_if_ready_and_make_new_image(train_id, plot_data, module_data)

        return img
    

        
        